function A_5_3
close all;
%RKV 1:
A1 = zeros(4,4); A1(2,1)=1/2; A1(3,2)=1/2; A1(4,3)=1;
b1=[1/6;2/6;2/6;1/6]; c1 = [0;1/2;1/2;1];

%RKV 2:
A2 = zeros(5,5); A2(1:4,1:4)=A1; A2(5,:)=[b1' 0];
b2 = [1/6;2/6;2/6;0;1/6]; c2 = [c1;1];

%RKV 3:
A3 = A2;
b3 = [b1;0]; c3=c2;

% Startwerte:
y0=[0.8;0];
t0=0;

% Rechte Seite
f = @(t,y)[y(2);-3*y(1)]; 

% Exakte Loesung
y_exact = @(t) [0.8*cos(sqrt(3)*t);-0.8*sqrt(3)*sin(sqrt(3)*t)];

f_rel=zeros(3,10); % Matrix, in der in jeder Zeile die Fehler für ein Verfahren gespeichert werden
T=1; % Endzeit T
y_von_1= y_exact(1); % y(T)

% Bestimme h_i Vektor
h = 2.^(-1:-1:-10);

% Berechnung der Approximationen an y(1) mit den verschiednen
% Schrittweiten h(i), i=1,...,10: 
for i = 1:10 
    % Berechnung der Approx. mit den verschiedenen Verfahren:
    [~,y1] = expl_Runge_Kutta_Verfahren(t0,y0,h(i),f,T,A1,b1,c1);
    [~,y2] = expl_Runge_Kutta_Verfahren(t0,y0,h(i),f,T,A2,b2,c2);
    [~,y3] = expl_Runge_Kutta_Verfahren(t0,y0,h(i),f,T,A3,b3,c3);
    
    %hier werden die absoluten Fehler berechnet:
    f_rel(1,i)= norm(y1(:,end)-y_von_1);
    f_rel(2,i)= norm(y2(:,end)-y_von_1);
    f_rel(3,i)= norm(y3(:,end)-y_von_1);
   
end

%Plot der Norm des absoluten Fehlers gegen die Schrittweite h:
loglog(h,f_rel(1,:),'--g',h,f_rel(2,:),'r',h,f_rel(3,:),'+c',h,h.^3,':',h,h.^4,':');
legend('RKV1','RKV2','RKV3','h^3','h^4','location','NorthWest');
title('Fehlerplot')
ylabel('Norm des absoluten Fehlers')
xlabel('Schrittweite h')
end